# encoding: utf-8
import datetime
from south.db import db
from south.v2 import SchemaMigration
from django.db import models

class Migration(SchemaMigration):
    
    def forwards(self, orm):
        
        # Adding model 'Cdr'
        db.create_table('asterisk_cdr', (
            ('src', self.gf('django.db.models.fields.CharField')(max_length=80)),
            ('userfield', self.gf('django.db.models.fields.CharField')(max_length=255)),
            ('calldate', self.gf('django.db.models.fields.DateTimeField')()),
            ('uniqueid', self.gf('django.db.models.fields.CharField')(max_length=40)),
            ('amaflags', self.gf('django.db.models.fields.IntegerField')()),
            ('accountcode', self.gf('django.db.models.fields.CharField')(max_length=20)),
            ('dst', self.gf('django.db.models.fields.CharField')(max_length=80)),
            ('dcontext', self.gf('django.db.models.fields.CharField')(max_length=80)),
            ('lastapp', self.gf('django.db.models.fields.CharField')(max_length=80)),
            ('lastdata', self.gf('django.db.models.fields.CharField')(max_length=80)),
            ('clid', self.gf('django.db.models.fields.CharField')(max_length=80)),
            ('disposition', self.gf('django.db.models.fields.CharField')(max_length=80)),
            ('duration', self.gf('django.db.models.fields.IntegerField')()),
            ('billsec', self.gf('django.db.models.fields.IntegerField')()),
            ('dstchannel', self.gf('django.db.models.fields.CharField')(max_length=80)),
            ('id', self.gf('django.db.models.fields.AutoField')(primary_key=True)),
            ('channel', self.gf('django.db.models.fields.CharField')(max_length=80)),
        ))
        db.send_create_signal('asterisk', ['Cdr'])

        # Adding model 'Record'
        db.create_table('asterisk_record', (
            ('recall', self.gf('django.db.models.fields.CharField')(max_length=200)),
            ('caller', self.gf('django.db.models.fields.CharField')(max_length=80)),
            ('ts', self.gf('django.db.models.fields.DateTimeField')()),
            ('recout', self.gf('django.db.models.fields.CharField')(max_length=200)),
            ('record', self.gf('django.db.models.fields.AutoField')(primary_key=True)),
            ('callee', self.gf('django.db.models.fields.CharField')(max_length=80)),
            ('recin', self.gf('django.db.models.fields.CharField')(max_length=200)),
        ))
        db.send_create_signal('asterisk', ['Record'])

        # Adding model 'AsteriskProfile'
        db.create_table('asterisk_asteriskprofile', (
            ('description', self.gf('django.db.models.fields.CharField')(max_length=25, null=True, blank=True)),
            ('internal_number', self.gf('django.db.models.fields.CharField')(max_length=10)),
            ('id', self.gf('django.db.models.fields.AutoField')(primary_key=True)),
            ('user', self.gf('django.db.models.fields.related.ForeignKey')(to=orm['auth.User'], null=True, blank=True)),
        ))
        db.send_create_signal('asterisk', ['AsteriskProfile'])

        # Adding model 'AsteriskAddressBook'
        db.create_table('asterisk_asteriskaddressbook', (
            ('phone_number', self.gf('django.db.models.fields.CharField')(max_length=10)),
            ('user', self.gf('django.db.models.fields.related.ForeignKey')(to=orm['auth.User'], null=True, blank=True)),
            ('is_internal', self.gf('django.db.models.fields.BooleanField')(default=False, blank=True)),
            ('id', self.gf('django.db.models.fields.AutoField')(primary_key=True)),
            ('description', self.gf('django.db.models.fields.CharField')(max_length=15)),
        ))
        db.send_create_signal('asterisk', ['AsteriskAddressBook'])

        # Adding model 'Settings'
        db.create_table('asterisk_settings', (
            ('last_modifier', self.gf('django.db.models.ForeignKey')(blank=True, related_name='asterisk_settings_last_modifier', null=True, to=orm['auth.User'])),
            ('creator', self.gf('django.db.models.ForeignKey')(blank=True, related_name='asterisk_settings_creator', null=True, to=orm['auth.User'])),
            ('type', self.gf('django.db.models.fields.CharField')(max_length=20)),
            ('description', self.gf('django.db.models.fields.TextField')(null=True, blank=True)),
            ('value', self.gf('django.db.models.fields.CharField')(max_length=500, null=True, blank=True)),
            ('date_create', self.gf('django.db.models.fields.DateTimeField')(null=True, blank=True)),
            ('date_last_modify', self.gf('django.db.models.fields.DateTimeField')(null=True, blank=True)),
            ('id', self.gf('django.db.models.fields.AutoField')(primary_key=True)),
            ('name', self.gf('django.db.models.fields.CharField')(max_length=100)),
        ))
        db.send_create_signal('asterisk', ['Settings'])
    
    
    def backwards(self, orm):
        
        # Deleting model 'Cdr'
        db.delete_table('asterisk_cdr')

        # Deleting model 'Record'
        db.delete_table('asterisk_record')

        # Deleting model 'AsteriskProfile'
        db.delete_table('asterisk_asteriskprofile')

        # Deleting model 'AsteriskAddressBook'
        db.delete_table('asterisk_asteriskaddressbook')

        # Deleting model 'Settings'
        db.delete_table('asterisk_settings')
    
    
    models = {
        'asterisk.asteriskaddressbook': {
            'Meta': {'object_name': 'AsteriskAddressBook'},
            'description': ('django.db.models.fields.CharField', [], {'max_length': '15'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'is_internal': ('django.db.models.fields.BooleanField', [], {'default': 'False', 'blank': 'True'}),
            'phone_number': ('django.db.models.fields.CharField', [], {'max_length': '10'}),
            'user': ('django.db.models.fields.related.ForeignKey', [], {'to': "orm['auth.User']", 'null': 'True', 'blank': 'True'})
        },
        'asterisk.asteriskprofile': {
            'Meta': {'object_name': 'AsteriskProfile'},
            'description': ('django.db.models.fields.CharField', [], {'max_length': '25', 'null': 'True', 'blank': 'True'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'internal_number': ('django.db.models.fields.CharField', [], {'max_length': '10'}),
            'user': ('django.db.models.fields.related.ForeignKey', [], {'to': "orm['auth.User']", 'null': 'True', 'blank': 'True'})
        },
        'asterisk.cdr': {
            'Meta': {'object_name': 'Cdr'},
            'accountcode': ('django.db.models.fields.CharField', [], {'max_length': '20'}),
            'amaflags': ('django.db.models.fields.IntegerField', [], {}),
            'billsec': ('django.db.models.fields.IntegerField', [], {}),
            'calldate': ('django.db.models.fields.DateTimeField', [], {}),
            'channel': ('django.db.models.fields.CharField', [], {'max_length': '80'}),
            'clid': ('django.db.models.fields.CharField', [], {'max_length': '80'}),
            'dcontext': ('django.db.models.fields.CharField', [], {'max_length': '80'}),
            'disposition': ('django.db.models.fields.CharField', [], {'max_length': '80'}),
            'dst': ('django.db.models.fields.CharField', [], {'max_length': '80'}),
            'dstchannel': ('django.db.models.fields.CharField', [], {'max_length': '80'}),
            'duration': ('django.db.models.fields.IntegerField', [], {}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'lastapp': ('django.db.models.fields.CharField', [], {'max_length': '80'}),
            'lastdata': ('django.db.models.fields.CharField', [], {'max_length': '80'}),
            'src': ('django.db.models.fields.CharField', [], {'max_length': '80'}),
            'uniqueid': ('django.db.models.fields.CharField', [], {'max_length': '40'}),
            'userfield': ('django.db.models.fields.CharField', [], {'max_length': '255'})
        },
        'asterisk.record': {
            'Meta': {'object_name': 'Record'},
            'callee': ('django.db.models.fields.CharField', [], {'max_length': '80'}),
            'caller': ('django.db.models.fields.CharField', [], {'max_length': '80'}),
            'recall': ('django.db.models.fields.CharField', [], {'max_length': '200'}),
            'recin': ('django.db.models.fields.CharField', [], {'max_length': '200'}),
            'record': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'recout': ('django.db.models.fields.CharField', [], {'max_length': '200'}),
            'ts': ('django.db.models.fields.DateTimeField', [], {})
        },
        'asterisk.settings': {
            'Meta': {'object_name': 'Settings'},
            'creator': ('django.db.models.ForeignKey', [], {'blank': 'True', 'related_name': "'asterisk_settings_creator'", 'null': 'True', 'to': "orm['auth.User']"}),
            'date_create': ('django.db.models.fields.DateTimeField', [], {'null': 'True', 'blank': 'True'}),
            'date_last_modify': ('django.db.models.fields.DateTimeField', [], {'null': 'True', 'blank': 'True'}),
            'description': ('django.db.models.fields.TextField', [], {'null': 'True', 'blank': 'True'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'last_modifier': ('django.db.models.ForeignKey', [], {'blank': 'True', 'related_name': "'asterisk_settings_last_modifier'", 'null': 'True', 'to': "orm['auth.User']"}),
            'name': ('django.db.models.fields.CharField', [], {'max_length': '100'}),
            'type': ('django.db.models.fields.CharField', [], {'max_length': '20'}),
            'value': ('django.db.models.fields.CharField', [], {'max_length': '500', 'null': 'True', 'blank': 'True'})
        },
        'auth.group': {
            'Meta': {'object_name': 'Group'},
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'name': ('django.db.models.fields.CharField', [], {'unique': 'True', 'max_length': '80'}),
            'permissions': ('django.db.models.fields.related.ManyToManyField', [], {'to': "orm['auth.Permission']", 'blank': 'True'})
        },
        'auth.permission': {
            'Meta': {'unique_together': "(('content_type', 'codename'),)", 'object_name': 'Permission'},
            'codename': ('django.db.models.fields.CharField', [], {'max_length': '100'}),
            'content_type': ('django.db.models.fields.related.ForeignKey', [], {'to': "orm['contenttypes.ContentType']"}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'name': ('django.db.models.fields.CharField', [], {'max_length': '50'})
        },
        'auth.user': {
            'Meta': {'object_name': 'User'},
            'date_joined': ('django.db.models.fields.DateTimeField', [], {'default': 'datetime.datetime.now'}),
            'email': ('django.db.models.fields.EmailField', [], {'max_length': '75', 'blank': 'True'}),
            'first_name': ('django.db.models.fields.CharField', [], {'max_length': '30', 'blank': 'True'}),
            'groups': ('django.db.models.fields.related.ManyToManyField', [], {'to': "orm['auth.Group']", 'blank': 'True'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'is_active': ('django.db.models.fields.BooleanField', [], {'default': 'True', 'blank': 'True'}),
            'is_staff': ('django.db.models.fields.BooleanField', [], {'default': 'False', 'blank': 'True'}),
            'is_superuser': ('django.db.models.fields.BooleanField', [], {'default': 'False', 'blank': 'True'}),
            'last_login': ('django.db.models.fields.DateTimeField', [], {'default': 'datetime.datetime.now'}),
            'last_name': ('django.db.models.fields.CharField', [], {'max_length': '30', 'blank': 'True'}),
            'password': ('django.db.models.fields.CharField', [], {'max_length': '128'}),
            'user_permissions': ('django.db.models.fields.related.ManyToManyField', [], {'to': "orm['auth.Permission']", 'blank': 'True'}),
            'username': ('django.db.models.fields.CharField', [], {'unique': 'True', 'max_length': '30'})
        },
        'contenttypes.contenttype': {
            'Meta': {'unique_together': "(('app_label', 'model'),)", 'object_name': 'ContentType', 'db_table': "'django_content_type'"},
            'app_label': ('django.db.models.fields.CharField', [], {'max_length': '100'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'model': ('django.db.models.fields.CharField', [], {'max_length': '100'}),
            'name': ('django.db.models.fields.CharField', [], {'max_length': '100'})
        }
    }
    
    complete_apps = ['asterisk']
