/*
 * Asterisk -- An open source telephony toolkit.
 *
 * Javascript routines or accessing manager routines over HTTP.
 *
 * Copyright (C) 1999 - 2006, Digium, Inc.
 *
 * Mark Spencer <markster@digium.com>
 *
 * See http://www.asterisk.org for more information about
 * the Asterisk project. Please do not directly contact
 * any of the maintainers of this project for assistance;
 * the project provides a web site, mailing lists and IRC
 * channels for your use.
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License Version 2. See the LICENSE file
 * at the top of the source tree.
 *
 */


function Asterisk() {
    var me = this;
    var activePeers = new Array;
    var allPeers = new Array;
    var nonamePeers = new Array;
    var lastselect;
    var selecttarget;
    var imgfree = '<img src="/static/asterisk/img/free_small.gif" alt="Free" />';
    var imgbusy = '<img src="/static/asterisk/img/busy_small.gif" alt="Busy" />';
    var imgcallout = '<img src="/static/asterisk/img/outgoing_small.gif" alt="Out" />';
    var imgcallin =  '<img src="/static/asterisk/img/incoming_small.gif" alt="In" />';
    var imgrubrica =  '<img src="/static/asterisk/img/rubrica.gif"/>';
    var txtfree = 'Telefono libero';
    var txtbusy = 'Al telefono con : ';
    var txtcallout = 'Chiamata verso : ';
    var txtcallin = 'Chiamata da : ';
    
    this.setURL = function(url) {
        this.url = url;
    };
    this.setEventCallback = function(callback) {
        this.eventcallback = callback;
    };
    this.setDebug = function(debug) {
        this.debug = debug;
    };

    this.setDebug1 = function(debug) {
        this.debug1 = debug;
    };

    this.activePeersClear = function() {
        activePeers = new Array;
    }
    
    this.clearFreePeers = function() {
        for (h in allPeers) {
            pid = allPeers[h]
            if (!document.getElementById("statuspeer" + pid))
                continue;
                
            // Il controllo lo faccio solo per i telefoni NON liberi
            //
            //v = document.getElementById("msgpeer" + allPeers[h]).innerHTML;
            
            //if (v == txtfree)
            //    continue;
            
            isactive = me.peerAgainActive(pid);
            if (!isactive) {
                document.getElementById("statuspeer" + pid).innerHTML = "<a href='#' onclick='click_to_call2("+pid+")'>"+imgfree+"</a>";
                //document.getElementById("msgpeer" + pid).innerHTML = txtfree;
            }
        }
    }

    this.peerAgainActive = function(peer_id) {
        //me.showPeersArray();
        //me.showActiveArray();

        for (y in activePeers) {
            if (peer_id == activePeers[y])
                return true;
        }
        return false;
    } 

    this.parseResponse = function(t, callback) {
        var msgs = new Array();
        var inmsg = 0;
        var msgnum = 0;
        var x,y;
        var s = t.responseText;

        var allheaders = s.split('\r\n');
        if (me.debug) 
            me.debug.value = "\n";
        for (x=0;x<allheaders.length;x++) {
            if (allheaders[x].length) {
                var fields = allheaders[x].split(': ');
                if (!inmsg) {
                    msgs[msgnum] = new Object();
                    msgs[msgnum].headers = new Array();
                    msgs[msgnum].names = new Array();
                    y=0;
                }
                msgs[msgnum].headers[fields[0].toLowerCase()] = fields[1];
                msgs[msgnum].names[y++] = fields[0].toLowerCase();
                if (me.debug)
                    me.debug.value = me.debug.value + "field " + fields[0] + "/" + fields[1] + "\n";
                inmsg=1;
            } else {
                if (inmsg) {
                    if (me.debug)
                        me.debug.value = me.debug.value + " new message\n";
                    inmsg = 0;
                    msgnum++;
                }
            }
        }

        if (me.debug) {
            me.debug.value = me.debug.value + "msgnum is " + msgnum + " and array length is " + msgs.length + "\n";
            me.debug.value = me.debug.value + "length is " + msgs.length + "\n";
            var x, y;
            for (x=0;x<msgs.length;x++) {
                for (y=0;y<msgs[x].names.length;y++)  {
                    me.debug.value = me.debug.value + "msg "+ (x + 1) + "/" + msgs[x].names[y] + "/" + msgs[x].headers[msgs[x].names[y]] + "\n";
                }
            }
        }
        callback(msgs);
    };
    this.managerResponse = function(t) {
        me.parseResponse(t, me.callback);
    };
    this.doEvents = function(msgs) {
        me.eventcallback(msgs);
    };
    this.eventResponse = function(t) {
        me.parseResponse(t, me.doEvents);
    };

    this.sendRequest = function(request, callback) {
        var tmp;
        var opt = {
            method: 'get',
            asynchronous: true,
            onSuccess: this.managerResponse,
            onFailure: function(t) {
                alert("Error: " + t.status + ": " + t.statusText);
            }
        };
        me.callback = callback;
        opt.parameters = request;
        tmp = new Ajax.Request(this.url, opt);
    };

    this.sendLogin = function(callback) {
        var tmp;
        var opt = {
            method: 'get',
            asynchronous: true,
            onSuccess: this.managerResponse,
            onFailure: function(t) {
                alert("Error: " + t.status + ": " + t.statusText);
            }
        };
        me.callback = callback;
        tmp = new Ajax.Request('/asterisk/login/', opt);
    };

    this.pollEvents = function() {
        var tmp;
        var opt = {
            method: 'get',
            asynchronous: true,
            onSuccess: this.eventResponse,
            onFailure: function(t) {
                alert("Event Error: " + t.status + ": " + t.statusText);
            }
        };
        opt.parameters="action=waitevent";
        tmp = new Ajax.Request(this.url, opt);
    };
    
    this.getPeerId = function(channel_name) {
        if (!channel_name)
            return;
         
        var sipstring = channel_name.substring(3,0);
        var sipid = null;
        if (sipstring == "SIP") {
            start_i = channel_name.indexOf("/") + 1;
            end_i = channel_name.indexOf("-");
            if (start_i >= 0 && end_i > 0) {
                sipid = channel_name.substring(start_i, end_i);
            }
        }
        return sipid;
    }
    
    this.sipPeersDiv = function(id) {
        // Se l'interno non ha associato un AsteriskProfile (in pratica se non e'
        // presente nell'array sipname) non lo viusalizzo
        if (sipname[id]) {
            s = "<div id=sip" + id + " class='sippeer_small'>\n";
            s += "<div id='statuspeer"+id+"' class='infopeer_small'><a href='#' onclick='click_to_call2("+id+")'>"+imgfree+"</a></div>";
            s += "<span id='peerid_small'>"+sipname[id]+"</span>";
            s += "</div>";
            return s
        }
        //else {
        //    s += "<span id='peerid_small'>"+id+"</span>";
        //}
        return '';
    }

    this.getOrderPeers = function() {
        var peersOrdinati = new Array;
        for (key in sipname) {
            peersOrdinati.push(key);
        }
        nonamePeers.sort();
        for (x = 0; x < nonamePeers.length; x++) {
            peersOrdinati.push(nonamePeers[x]);
        }
        return peersOrdinati;
    }
    
    this.sipPeers = function(msgs) {
        var id = msgs.headers.objectname;
        allPeers.push(id);
        if (!sipname[id]) {
            nonamePeers.push(id);
        }
    }

    this.sipOthersNumbersDiv = function(descr, numero) {
        s = "<div class='sippeer_small'>\n";
        s += "<div class='infopeer_small'><a href=\"#\" onclick=\"click_to_call2('"+numero+"')\">"+imgrubrica+"</a></div>";
        s += "<span id='peerid_small'>"+descr+"</span>";
        s += "</div>";
        return s;       
    }

    this.alertPeersArray = function() {
        x = 'LIST PEERS : ';
        for (h in allPeers) {
            x = x + allPeers[h] + ", ";
        }
        alert(x);
    }
    
    this.showPeersArray = function() {
        if (me.debug1) {
            me.debug1.value = me.debug1.value + "LIST PEERS\n";
            for (h in allPeers) {
                me.debug1.value = me.debug1.value + allPeers[h] + "\n";
            }
        }
    }

    this.alertActiveArray = function() {
        x = 'LIST ACTIVE PEERS : ';
        for (h in activePeers) {
            x = x + activePeers[h] + ", ";
        }
        alert(x);
    }
    
    this.showActiveArray = function() {
        if (me.debug1) {
            me.debug1.value = me.debug1.value + "LIST ACTIVE PEERS\n";
            for (h in activePeers) {
                me.debug1.value = me.debug1.value + activePeers[h] + "\n";
            }
        }
    }
            
    this.sipStatusUpdate = function(msg) {
//        if (me.debug1) {
//            me.debug1.value = me.debug1.value + "EVENTO : "+msg.headers.event;
//            for (h in msg.headers) {
//                me.debug1.value = me.debug1.value + h + " : " + msg.headers[h] + "\n";
//            }
//        }
        if (msg.headers.event) {
            if (msg.headers.event == "Dial") {
                me.dialEvent(msg);
            } else if (msg.headers.event == "Hangup") {
                me.hungupEvent(msg);
            } else if (msg.headers.event == "Link") {
                me.linkEvent(msg);
            } else if (msg.headers.event == "Unlink") {
                me.unlinkEvent(msg);
            } else if (msg.headers.event == "ParkedCall") {
                me.parkedcallEvent(msg);
            } else if (msg.headers.event == "Status") {
                me.statusEvent(msg);
            }
        }
    }

    this.statusEvent = function(msg) {
        if (msg.headers.state) {
            if (msg.headers.state == "Ringing") {
                me.setRingingState(msg);
            } else if (msg.headers.state == "Ring") {
                me.setRingState(msg);
            } else if (msg.headers.state == "Up") {
                me.setUpState(msg);
            } //else if (msg.headers.event == "Unlink") {
            //    me.unlinkEvent(msg);
            //} //else if (msg.headers.event == "ParkedCall") {
//                me.parkedcallEvent(msg);
//            }        
//        }
        //if (msg.headers.callerid) {
        //    document.getElementById("statuspeer" + msg.headers.callerid).innerHTML = imgbusy;
        //}
        }
    }
        
    this.dialEvent = function(msg) {
        var callerid = null;
        var destip = null;
        
//        if (me.debug1) {
//            me.debug1.value = me.debug1.value + "DIAL EVENT\n";
//            for (h in msg.headers) {
//                me.debug1.value = me.debug1.value + h + " : " + msg.headers[h] + "\n";
//            }
//        }
        if (msg.headers.callerid) {
            callerid = msg.headers.callerid;
        }
        if (msg.headers.destination) {
            channel = msg.headers.destination;
            destip = me.getPeerId(channel);
        }
        
        if (document.getElementById("statuspeer" + callerid)) { 
            document.getElementById("statuspeer" + callerid).innerHTML = imgcallout;
            
            if (document.getElementById("statuspeer" + destip)) {
                //document.getElementById("msgpeer" + callerid).innerHTML = txtcallout + destip;
            }
            else {
                //document.getElementById("msgpeer" + callerid).innerHTML = txtcallout + "Unknown";
            }
        }
        
        if (document.getElementById("statuspeer" + destip)) {
            document.getElementById("statuspeer" + destip).innerHTML = imgcallin;
            //document.getElementById("msgpeer" + destip).innerHTML = txtcallin + callerid;
        }
    }

    this.hungupEvent = function(msg) {
//        if (me.debug1) {
//            me.debug1.value = me.debug1.value + "HUNGUP EVENT\n";
//            for (h in msg.headers) {
//                me.debug1.value = me.debug1.value + h + " : " + msg.headers[h] + "\n";
//            }
//        }
        
        if (msg.headers.channel) {
            channel = msg.headers.channel;
            sipid = me.getPeerId(channel);
            if (sipid) {
                document.getElementById("statuspeer"+sipid).innerHTML = "<a href='#' onclick='click_to_call2("+sipid+")'>"+imgfree+"</a>";
                //document.getElementById("msgpeer"+sipid).innerHTML = txtfree;
            }
        }
    } 
    

    this.linkEvent = function(msg) {
//        if (me.debug1) {
//            me.debug1.value = me.debug1.value + "LINK EVENT\n";
//            for (h in msg.headers) {
//                me.debug1.value = me.debug1.value + h + " : " + msg.headers[h] + "\n";
//            }
//        }                
        if (msg.headers.callerid1) {
            srcid = msg.headers.callerid1
        }
        else {
            srcid = me.getPeerId(msg.headers.channel1);
        }        
        
        if (msg.headers.callerid2) {
            destid = msg.headers.callerid2
        }

        if (document.getElementById("statuspeer" + srcid)) {
            document.getElementById("statuspeer" + srcid).innerHTML = imgbusy;
            //if (destid) {
                // Questa riga visualizza il num di telefono con cui si e' collegati
                //document.getElementById("msgpeer"+srcid).innerHTML = txtbusy + destid;
                
                // Per ora non lo visualizzo.
                //document.getElementById("msgpeer"+srcid).innerHTML = txtbusy + 'Unknown';
            //}
        }
        if (document.getElementById("statuspeer" + destid)) {
            document.getElementById("statuspeer" + destid).innerHTML = imgbusy;
            //if (srcid) {
                //document.getElementById("msgpeer"+destid).innerHTML = txtbusy + srcid;
            //}
        }
    }
 
    this.unlinkEvent = function(msg) {
//        if (me.debug1) {
//            me.debug1.value = me.debug1.value + "UNLINK EVENT\n";
//            for (h in msg.headers) {
//                me.debug1.value = me.debug1.value + h + " : " + msg.headers[h] + "\n";
//            }
//        }
//        if (document.getElementById("statuspeer" + msg.headers.callerid1)) {
//            document.getElementById("statuspeer" + msg.headers.callerid1).innerHTML = imgfree;
//        }
//        if (document.getElementById("statuspeer" + msg.headers.callerid2)) {
//            document.getElementById("statuspeer" + msg.headers.callerid2).innerHTML = imgfree;
//        }
    }
    
    this.parkedcallEvent = function(msg) {
//        if (me.debug1) {
//            me.debug1.value = me.debug1.value + "UNLINK EVENT\n";
//            for (h in msg.headers) {
//                me.debug1.value = me.debug1.value + h + " : " + msg.headers[h] + "\n";
//            }
//        }
        if (document.getElementById("statuspeer" + msg.headers.callerid1)) {
            document.getElementById("statuspeer" + msg.headers.callerid1).innerHTML = imgfree;
        }
        if (document.getElementById("statuspeer" + msg.headers.callerid2)) {
            document.getElementById("statuspeer" + msg.headers.callerid2).innerHTML = imgfree;
        }
    }
    
    this.setRingingState = function(msg) {
//        if (me.debug1) {
//            me.debug1.value = me.debug1.value + "RINGING STATE\n";
//            for (h in msg.headers) {
//                me.debug1.value = me.debug1.value + h + " : " + msg.headers[h] + "\n";
//            }              
//        }
        if (document.getElementById("statuspeer"+msg.headers.callerid)) {
            document.getElementById("statuspeer"+msg.headers.callerid).innerHTML = imgcallin;
            //document.getElementById("msgpeer"+msg.headers.callerid).innerHTML = txtcallin + msg.headers.callerid;
            activePeers.push(msg.headers.callerid);
        }
        
        channel = msg.headers.channel;
        sip = me.getPeerId(channel);
        if (document.getElementById("statuspeer"+sip)) {
            activePeers.push(sip);
        }
    }
    
    this.setRingState = function(msg) {
//        if (me.debug1) {
//            me.debug1.value = me.debug1.value + "RING STATE\n";
//            for (h in msg.headers) {
//                me.debug1.value = me.debug1.value + h + " : " + msg.headers[h] + "\n";
//            }
//        }

        if (document.getElementById("statuspeer"+msg.headers.callerid)) {
            document.getElementById("statuspeer"+msg.headers.callerid).innerHTML = imgcallout;
            //document.getElementById("msgpeer"+msg.headers.callerid).innerHTML = txtcallout + msg.headers.callerid;
            activePeers.push(msg.headers.callerid);
        }
    }
    
    this.setUpState = function(msg) {
//        if (me.debug1) {
//            me.debug1.value = me.debug1.value + "UP STATE\n";
//            for (h in msg.headers) {
//                me.debug1.value = me.debug1.value + h + " : " + msg.headers[h] + "\n";
//            }            
//        }
        if (!msg.headers.link) {
            activePeers.push(msg.headers.callerid);    
        }
        if (msg.headers.link) {
            var sipstring = msg.headers.link.substring(3,0);
            var fromip = null;
            var toip = null;

            if (sipstring == "SIP") {
                link = msg.headers.link;
                toip = me.getPeerId(link);
              
                if (msg.headers.callerid) {
                    fromip = msg.headers.callerid;
                }

                if (document.getElementById("statuspeer"+fromip)) {
                    document.getElementById("statuspeer"+fromip).innerHTML = imgbusy;
                    if (toip) {
                        //document.getElementById("msgpeer"+fromip).innerHTML = txtbusy + toip;
                        activePeers.push(fromip);
                    }
                    else
                        document.getElementById("msgpeer"+fromip).innerHTML = txtbusy + "Unknown";
                }
                if (document.getElementById("statuspeer"+toip)) {
                    document.getElementById("statuspeer"+toip).innerHTML = imgbusy;
                    if (fromip) {
                        //document.getElementById("msgpeer"+toip).innerHTML = txtbusy + fromip;
                        activePeers.push(toip);
                    }
                    //else
                        //document.getElementById("msgpeer"+toip).innerHTML = txtbusy + "Unknown";
                }                
            }
        }
    }  
};

var asteriskEngine = new Asterisk();
