var NUM_PER_PAGE = 100;
var grid_giorni;
var URL = '/asterisk/cdr/ajax/list';

Ext.onReady(function(){       
    var nav_filter = new Ext.Panel({
                title: 'Parametri ricerca',
                collapsible: true,
                collapsed: true,
                contentEl: 'content_navigation_filter'
            });
    
    nav_filter.render('navigation_filter');
    
    /***********************
     * RENDER FUNCTIONS
     ***********************/
   
    /***********************
     * END RENDER FUNCTIONS
     ***********************/
    
    var myProxy = new Ext.data.HttpProxy({
        url: URL,
        method: 'GET'
    });

    var myReader = new Ext.data.JsonReader({
        root: 'data',
        totalProperty: 'total',
        id: 'id',
        fields: [      
            {name: 'id'},
            {name: 'calldate'},
            {name: 'calldate_for_group'},
            {name: 'src'},
            {name: 'dst'},           
            {name: 'dcontext'},
            {name: 'duration'},
            {name: 'billsec'},
            {name: 'disposition'}
            
        ]
    });
    
    var cm = new Ext.grid.ColumnModel([
        {header: "Data", width: 15, type: 'date', renderer: Ext.util.Format.dateRenderer('d/m/Y H:i'),
        	dataIndex: "calldate"},
        {header: "Data", width: 1, type: 'date', renderer: Ext.util.Format.dateRenderer('d/m/Y'),
        	dataIndex: "calldate_for_group", hidden:true},            
        {header: "Effettuata da", width: 15, dataIndex: "src"},
        {header: "Numero chiamato", width: 15, dataIndex: "dst"},
        {header: "Contesto", width: 10, dataIndex: "dcontext"},
        {header: "Durata Tot.", width: 10, dataIndex: "duration"},
        {header: "Durata Chiamata", width: 10, dataIndex: "billsec"},
        {header: "Disposition", width: 10, dataIndex: "disposition"},
    ]);

    // Rendo le colonne sortabili di defautl
    cm.defaultSortable = true;
    
    // create the Data Store
    ds = new Ext.data.GroupingStore({
        proxy: myProxy,
        reader: myReader,
        remoteSort: true,
        groupField: 'calldate_for_group',
        remoteGroup: true
    });

    ds.setDefaultSort('calldate', 'DESC');

    bbar = new Ext.PagingToolbar({
        pageSize: NUM_PER_PAGE,
        store: ds,
        displayInfo: true,
        displayMsg: 'Visualizzo Chiamate {0} - {1} di {2}',
        emptyMsg: "Nessuna chiamata da visualizzare"
    });
    
    grid_giorni = new Ext.grid.GridPanel({
        el:'grid_chiamate',
        title:'Lista Chiamate',
        loadMask: true,        
        viewConfig: {forceFit: true},      
        autoHeight : true,
        enableColumnHide : false, // Tolgo dal context menu degli header il valore "Columns"
        store: ds,
        cm: cm,
        
        view: new Ext.grid.GroupingView({
            forceFit:true,
            enableNoGroups:false,
            enableGrouping:false,
            sortAscText: 'Ordinamento crescente',
            sortDescText: 'Ordinamento decrescente',
            groupByText : 'Raggruppa per questo campo',
            groupTextTpl: '{text}'
        }),
                
        bbar: bbar,
        plugins: new Ext.grid.GroupSummary()
    });
    
    grid_giorni.render();

    myForm = new Ext.form.BasicForm('search_form', {'standardSubmit':true});
    grid_giorni.getStore().baseParams = myForm.getValues();    
    // trigger the data store load
    ds.load({params:{start:0, limit:NUM_PER_PAGE}});
    	    
});