var logins = new Object;
var logoffs = new Object;
var channels = new Object;
var pongs = new Object;
var loggedon = -1;
var selectedchan = null;
var hungupchan = "";
var transferedchan = "";

var demo = new Object;

function loggedOn() {
    if (loggedon == 1)
        return;
    loggedon = 1;
    //updateButtons();
    $('statusbar').innerHTML = "<i>Retrieving channel status...</i>";
    astmanEngine.pollEvents();
    astmanEngine.sendRequest('action=status', demo.channels);
    $('channellist').innerHTML = astmanEngine.channelTable(demo.channelCallback);
}

function clearChannelList() {
    //$('channellist').innerHTML = "<i class='light'>Not connected</i>";
}

function loggedOff() {
    if (loggedon == 0)
        return;
    loggedon = 0;
    selectedchan = null;
    updateButtons();
    astmanEngine.channelClear();
    clearChannelList();
}

function updateButtons()
{
    if ($(selectedchan)) {
        $('transfer').disabled = 0;
        $('hangup').disabled = 0;
    } else {
        $('transfer').disabled = 1;
        $('hangup').disabled = 1;
        selectedchan = null;
    }
    if (loggedon) {
        $('username').disabled = 1;
        $('secret').disabled = 1;
        $('logoff').disabled = 0;
        $('login').disabled = 1;
        $('refresh').disabled = 0;
    } else {
        $('username').disabled = 0;
        $('secret').disabled = 0;
        $('logoff').disabled = 1;
        $('login').disabled = 0;
        $('refresh').disabled = 1;
    }
}

demo.channelCallback = function(target) {
    selectedchan = target;
    updateButtons();
}

demo.channels = function(msgs) {
    resp = msgs[0].headers['response'];
    if (resp == "Success") {
        loggedOn();
    } else
        loggedOff();

    for (i=1;i<msgs.length - 1;i++) 
        astmanEngine.channelUpdate(msgs[i]);
    $('channellist').innerHTML = astmanEngine.channelTable(demo.channelCallback);
    $('statusbar').innerHTML = "Ready";
}

demo.logins = function(msgs) {
    $('statusbar').innerHTML = msgs[0].headers['message'];
    resp = msgs[0].headers['response'];
    if (resp == "Success")
        loggedOn();
    else
        loggedOff();
};


demo.logoffs = function(msgs) {
    $('statusbar').innerHTML = msgs[0].headers['message'];
    loggedOff();
};

demo.hungup = function(msgs) {
    $('statusbar').innerHTML = "Hungup " + hungupchan;
}

demo.transferred = function(msgs) {
    $('statusbar').innerHTML = "Transferred " + transferredchan;
}

function doHangup() {
    hungupchan = selectedchan;
    astmanEngine.sendRequest('action=hangup&channel=' + selectedchan, demo.hungup);
}

function doStatus() {
    $('statusbar').innerHTML = "<i>Updating channel status...</i>";
    astmanEngine.channelClear();
    astmanEngine.sendRequest('action=status', demo.channels);
}   
    
function doLogin() {
    $('statusbar').innerHTML = "<i>Logging in...</i>";
    astmanEngine.sendRequest('action=login&username=' + $('username').value + "&secret=" + $('secret').value, demo.logins);
}

function doTransfer() {
    var channel = astmanEngine.channelInfo(selectedchan);
    var exten = prompt("Enter new extension for " + selectedchan);
    var altchan;
    if (exten) {
        if (channel.link) {
            if (confirm("Transfer " + channel.link + " too?"))
                altchan = channel.link;
        }
        if (altchan) {
            transferredchan = selectedchan + " and " + altchan + " to " + exten;
            astmanEngine.sendRequest('action=redirect&channel=' + selectedchan + "&priority=1&extrachannel=" + altchan + "&exten=" + exten, demo.transferred);
        } else {
            transferredchan = selectedchan + " to " + exten;
            astmanEngine.sendRequest('action=redirect&channel=' + selectedchan + "&priority=1&exten=" + exten, demo.transferred);
        }
    }
}

function doLogoff() {
    $('statusbar').innerHTML = "<i>Logging off...</i>";
    astmanEngine.sendRequest('action=logoff', demo.logoffs);
}

demo.pongs  = function(msgs) {
    resp = msgs[0].headers['response'];
    if (resp == "Pong") {
        $('statusbar').innerHTML = "<i>Logged...</i>";
        loggedOn();
    } else {
        $('statusbar').innerHTML = "<i>Please login...</i>";
        loggedOff();
    }
}

demo.eventcb = function(msgs) {
    var x;
    if (loggedon) {
        for (i=1;i<msgs.length - 1;i++) {
            astmanEngine.channelUpdate(msgs[i]);
        }
        $('channellist').innerHTML = astmanEngine.channelTable(demo.channelCallback);
        astmanEngine.pollEvents();
    }
    updateButtons();
}

function localajaminit() {
    //astmanEngine.setURL('http://192.168.100.250:8088/asterisk/rawman/');
    astmanEngine.setURL('/asterisk/proxy/');
    astmanEngine.setEventCallback(demo.eventcb);
    //astmanEngine.setDebug($('ditto'));
    clearChannelList();
    $('statusbar').innerHTML = "<i>Logging in...</i>";
    astmanEngine.sendRequest('action=ping', demo.pongs);    
    astmanEngine.sendRequest('action=login&username=caller&secret=YTR11%26^qw', demo.logins);
}

Ext.onReady(function(){
    localajaminit();
})
