from django import template
from django.forms.util import flatatt
from django.conf import settings
from jumbo.utils.functions import get_settings

def click_to_call(number, get_link=False):
    if 'asterisk' not in settings.INSTALLED_APPS:
        return  {'asterisk': False, 'number': number}

    ext_prefix = get_settings('asterisk.settings', 'ASTERISK_PREFIX_EXTERNAL')

    if not number:
        return ''

    is_number = False
    media_url = settings.MEDIA_URL
    number_d = None

    if number:
        number_d = number.replace('+', '00')

    if number_d and number_d.isdigit():
        is_number = True

    if get_link:
        img_phone = "<img src='%(url)sasterisk/img/call.jpg' class='img_phone' title='%(number)s' alt='%(number)s' />" % {
            'url': settings.MEDIA_URL,
            'number': number
        }
        if is_number:
            return "<a href='#' onclick=\"click_to_call('%s')\" class='click_to_call'>%s</a>" % (number, img_phone)
        else:
            return "<img src='%(url)sasterisk/img/wrong_call.jpg' class='img_phone' title='%(number)s' alt='%(number)s' />" % {
                'url': settings.MEDIA_URL,
                'number': number
            }

    return  {'asterisk': True, 'ext_prefix': ext_prefix, 'media_url': media_url, 
             'number': number, 'is_number': is_number}

def clean_number(number, add_internal_prefix=True):
    ext_prefix = get_settings('asterisk.settings', 'ASTERISK_PREFIX_EXTERNAL')
    number = number.replace('+', '00')
    if add_internal_prefix:
        return str("%s%s" % (ext_prefix, number))
    else:
        return str(number)

